import { createApp } from 'vue'
import { createPinia } from 'pinia'
import App from './App.vue'
import router from './router'
import moment from 'moment'
import { Notify, Toast, Dialog } from 'vant';
import VConsole from 'vconsole'

moment.locale('zh-cn')

if (import.meta.env.VITE_DEBUG === "true") {
 const vConsole = new VConsole();
}

const app = createApp(App)
app.use(createPinia())
app.use(router)
app.use(Notify)
app.use(Toast)
app.use(Dialog)
// app.use(vConsole)
app.mount('#app')

