import { get, put, post, File, deleteReq } from '@/utils/http'

const baseURL = import.meta.env.VITE_LOCAL== 'true' ? '/api' : import.meta.env.VITE_HTTP_BASE_URL

const api = {
    // 首页查询
    getRepayPlantList(data = {}) {
        return post(`${baseURL}/app/api/app/repayment/details`, data)
    },
    //还款计划明细
    getRepayPlanDetail(data={}){
        return post(`${baseURL}/app/api/app/project/repayment/details`, data)
    },
    //违约金明细
    getLiquidatedDetail(data={}){
        return post(`${baseURL}/app/api/app/liquidated/damages/details`, data)
    },
    //违约金每日明细
    getDailyLiquidatedDetail(data={}){
        return post(`${baseURL}/app/api/app/day/liquidated/damages/details`, data)
    },
    //支付
    getPay(data={}){
        return post(`${baseURL}/app/api/app/repayment/payment`, data)
    }
};

export default api;


