import { createRouter, createWebHashHistory } from 'vue-router'
import routes from '~pages'

let realRoutes = routes;

if (import.meta.env.PROD) {
  let reg = new RegExp(`${import.meta.env.VITE_TARGET}`);
  realRoutes = realRoutes.filter((route) => reg.test(route.name))
}

console.info('已渲染路由--', realRoutes);

const router = createRouter({
  history: createWebHashHistory(import.meta.env.VITE_HTTP_BASE_URL),
  routes: realRoutes,
})

export default router